window.Gleam.initSearch([{"doc":"dove","title":"dove","content":"![dove](https://raw.githubusercontent.com/massivefermion/dove/main/banner.jpg)\n\n[![Package Version](https://img.shields.io/hexpm/v/dove)](https://hex.pm/packages/dove)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/dove/)\n\n# dove\n\nHTTP client written in and for Gleam\n\n**Very experimental, use at your own risk!**\n\n## &lt;img width=32 src=&quot;https://raw.githubusercontent.com/massivefermion/dove/main/icon.png&quot;&gt; Quick start\n\n```sh\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## &lt;img width=32 src=&quot;https://raw.githubusercontent.com/massivefermion/dove/main/icon.png&quot;&gt; Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add dove\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/dove&gt;.\n","url":"index.html"},{"doc":"dove/response","title":"Body","content":"pub type Body(a) {\n  JSONDecoded(a)\n  PlainText(String)\n  OctetStream(BitArray)\n  HeadersSayJSON(String)\n  InvalidOrUnexpectedJSON(BitArray, json.DecodeError)\n}\n\nJSONDecoded(a)\n\n\nPlainText(String)\n\n\nOctetStream(BitArray)\n\n\nHeadersSayJSON(String)\n\n\nInvalidOrUnexpectedJSON(BitArray, json.DecodeError)\n\n\nSynonyms:\ndove/response.Body\ndove/response Body","url":"dove/response.html#Body"},{"doc":"dove/response","title":"dove/response","content":"","url":"dove/response.html"},{"doc":"dove/error","title":"Error","content":"pub type Error {\n  MoreNeeded\n  InvalidHeaders\n  WrongPacketType\n  InvalidStatusLine\n  TCPError(mug.Error)\n  UnableToSendRequest\n  HttpsNotSupportedYet\n  InvalidChunkedResponse\n  DecompressionError(String)\n  InvalidHeaderName(#(String, String))\n  InvalidHeaderValue(#(String, String))\n}\n\nMoreNeeded\n\n\nInvalidHeaders\n\n\nWrongPacketType\n\n\nInvalidStatusLine\n\n\nTCPError(mug.Error)\n\n\nUnableToSendRequest\n\n\nHttpsNotSupportedYet\n\n\nInvalidChunkedResponse\n\n\nDecompressionError(String)\n\n\nInvalidHeaderName(#(String, String))\n\n\nInvalidHeaderValue(#(String, String))\n\n\nSynonyms:\ndove/error.Error\ndove/error Error","url":"dove/error.html#Error"},{"doc":"dove/error","title":"dove/error","content":"","url":"dove/error.html"},{"doc":"dove/request","title":"Body","content":"pub type Body {\n  JSON(String)\n  PlainText(String)\n  OctetStream(BitArray)\n}\n\nJSON(String)\n\n\nPlainText(String)\n\n\nOctetStream(BitArray)\n\n\nSynonyms:\ndove/request.Body\ndove/request Body","url":"dove/request.html#Body"},{"doc":"dove/request","title":"build_delete","content":"pub fn build_delete(\n  headers: List(#(String, String)),\n  path: String,\n  query: List(#(String, String)),\n) -&gt; Request(Option(Body))\n\nSynonyms:\ndove/request.build_delete\ndove/request build_delete","url":"dove/request.html#build_delete"},{"doc":"dove/request","title":"build_get","content":"pub fn build_get(\n  headers: List(#(String, String)),\n  path: String,\n  query: List(#(String, String)),\n) -&gt; Request(Option(Body))\n\nSynonyms:\ndove/request.build_get\ndove/request build_get","url":"dove/request.html#build_get"},{"doc":"dove/request","title":"build_patch","content":"pub fn build_patch(\n  headers: List(#(String, String)),\n  path: String,\n  query: List(#(String, String)),\n  body: Body,\n) -&gt; Request(Option(Body))\n\nSynonyms:\ndove/request.build_patch\ndove/request build_patch","url":"dove/request.html#build_patch"},{"doc":"dove/request","title":"build_post","content":"pub fn build_post(\n  headers: List(#(String, String)),\n  path: String,\n  query: List(#(String, String)),\n  body: Body,\n) -&gt; Request(Option(Body))\n\nSynonyms:\ndove/request.build_post\ndove/request build_post","url":"dove/request.html#build_post"},{"doc":"dove/request","title":"build_put","content":"pub fn build_put(\n  headers: List(#(String, String)),\n  path: String,\n  query: List(#(String, String)),\n  body: Body,\n) -&gt; Request(Option(Body))\n\nSynonyms:\ndove/request.build_put\ndove/request build_put","url":"dove/request.html#build_put"},{"doc":"dove/request","title":"build_request","content":"pub fn build_request(\n  method: Method,\n  headers: List(#(String, String)),\n  path: String,\n  query: List(#(String, String)),\n  body: Option(Body),\n) -&gt; Request(Option(Body))\n\nSynonyms:\ndove/request.build_request\ndove/request build_request","url":"dove/request.html#build_request"},{"doc":"dove/request","title":"dove/request","content":"","url":"dove/request.html"},{"doc":"dove","title":"Connection","content":"pub opaque type Connection(a)\n\n\nSynonyms:\ndove.Connection\ndove Connection","url":"dove.html#Connection"},{"doc":"dove","title":"RequestOption","content":"pub type RequestOption(a) {\n  JSONDecoder(\n    fn(dynamic.Dynamic) -&gt; Result(a, List(dynamic.DecodeError)),\n  )\n}\n\nJSONDecoder(\n  fn(dynamic.Dynamic) -&gt; Result(a, List(dynamic.DecodeError)),\n)\n\n\nSynonyms:\ndove.RequestOption\ndove RequestOption","url":"dove.html#RequestOption"},{"doc":"dove","title":"connect","content":"pub fn connect(\n  host: String,\n  port: Int,\n  timeout: Int,\n) -&gt; Result(Connection(a), Error)\n\nSynonyms:\ndove.connect\ndove connect","url":"dove.html#connect"},{"doc":"dove","title":"get_response","content":"pub fn get_response(\n  conn: Connection(a),\n  ref: Reference,\n) -&gt; #(Connection(a), Result(Response(Option(Body(a))), Error))\n\nSynonyms:\ndove.get_response\ndove get_response","url":"dove.html#get_response"},{"doc":"dove","title":"receive","content":"pub fn receive(\n  conn: Connection(a),\n  timeout: Int,\n) -&gt; Connection(a)\n\nSynonyms:\ndove.receive\ndove receive","url":"dove.html#receive"},{"doc":"dove","title":"request","content":"pub fn request(\n  conn: Connection(a),\n  request: Request(Option(Body)),\n  options: List(RequestOption(a)),\n) -&gt; Result(#(Connection(a), Reference), Error)\n\nSynonyms:\ndove.request\ndove request","url":"dove.html#request"},{"doc":"dove","title":"shutdown","content":"pub fn shutdown(\n  conn: Connection(a),\n) -&gt; Result(\n  List(#(Reference, Result(Response(Option(Body(a))), Error))),\n  Error,\n)\n\nSynonyms:\ndove.shutdown\ndove shutdown","url":"dove.html#shutdown"},{"doc":"dove","title":"dove","content":"","url":"dove.html"}]);